/*
 * Copyright COCKTAIL (www.cocktail.org), 1995, 2012 This software 
 * is governed by the CeCILL license under French law and abiding by the
 * rules of distribution of free software. You can use, modify and/or 
 * redistribute the software under the terms of the CeCILL license as 
 * circulated by CEA, CNRS and INRIA at the following URL 
 * "http://www.cecill.info". 
 * As a counterpart to the access to the source code and rights to copy, modify 
 * and redistribute granted by the license, users are provided only with a 
 * limited warranty and the software's author, the holder of the economic 
 * rights, and the successive licensors have only limited liability. In this 
 * respect, the user's attention is drawn to the risks associated with loading,
 * using, modifying and/or developing or reproducing the software by the user 
 * in light of its specific status of free software, that may mean that it
 * is complicated to manipulate, and that also therefore means that it is 
 * reserved for developers and experienced professionals having in-depth
 * computer knowledge. Users are therefore encouraged to load and test the 
 * software's suitability as regards their requirements in conditions enabling
 * the security of their systems and/or data to be ensured and, more generally, 
 * to use and operate it in the same conditions as regards security. The
 * fact that you are presently reading this means that you have had knowledge 
 * of the CeCILL license and that you accept its terms.
 */
package org.cocktail.carambole.server.components;

// Generated by the WOLips Templateengine Plug-in at 8 janv. 2007 16:44:00

import org.cocktail.carambole.server.MyAjaxPage;
import org.cocktail.carambole.server.NavigationCtrl;
import org.cocktail.fwkcktldepense.server.finder.FinderArticle;
import org.cocktail.fwkcktldepense.server.metier.EOAttribution;
import org.cocktail.fwkcktldepense.server.metier.EOFournisseur;
import org.cocktail.fwkcktldepense.server.metier.EOTypeAchat;

import com.webobjects.appserver.WOComponent;
import com.webobjects.appserver.WOContext;
import com.webobjects.appserver.WODisplayGroup;
import com.webobjects.foundation.NSArray;
import com.webobjects.foundation.NSDictionary;
import com.webobjects.foundation.NSMutableDictionary;
import com.webobjects.foundation.NSTimestamp;

public class ArticleRechercheAvancee extends MyAjaxPage {

	private static final long serialVersionUID = 1L;
	public boolean isRechercheAvanceeDirecte = false;

	public ArticleRechercheAvancee(WOContext context) {
		super(context);
	}

	public WOComponent annuler() {
		dgArticles().queryBindings().removeAllObjects();
		return NavigationCtrl.goToSavedBonDeCommande(session, laCommandeEnCours(), null, "Articles");
	}

	public WOComponent revenir() {
		ArticleListeSelection nextPage = (ArticleListeSelection) session.getSavedPageWithName("ArticleListeSelection");
		return nextPage;
	}

	public WOComponent rechercher() {
		ArticleListeSelection nextPage = null;

		if (laCommandeEnCours() != null) {
			WODisplayGroup dg = dgArticles();
			@SuppressWarnings("unchecked")
			NSMutableDictionary<String, Object> bdgs = dg.queryBindings();
			String fouCode = (String) bdgs.objectForKey("fouCode");
			String fouNom = (String) bdgs.objectForKey("fouNom");
			String cnCode = (String) bdgs.objectForKey("cnCode");
			String cnLibelle = (String) bdgs.objectForKey("cnLibelle");
			String libelle = (String) bdgs.objectForKey("libelle");
			String reference = (String) bdgs.objectForKey("reference");
			String attributionLibelle = (String) bdgs.objectForKey("attributionLibelle");
			Boolean onMarche = (Boolean) bdgs.objectForKey("onMarche");
			if (onMarche != null && onMarche.booleanValue() == false) {
				bdgs.removeObjectForKey("onMarche");
			}
			if (fouCode != null && fouCode.equals("") == false) {
				bdgs.setObjectForKey(fouCode, "fouCode");
			}
			if (fouNom != null && fouNom.equals("") == false) {
				bdgs.setObjectForKey(fouNom, "fouNom");
			}
			if (cnCode != null && cnCode.equals("") == false) {
				bdgs.setObjectForKey(cnCode, "cnCode");
			}
			if (cnLibelle != null && cnLibelle.equals("") == false) {
				bdgs.setObjectForKey(cnLibelle, "cnLibelle");
			}
			if (libelle != null && libelle.equals("") == false) {
				bdgs.setObjectForKey(libelle, "libelle");
			}
			if (reference != null && reference.equals("") == false) {
				bdgs.setObjectForKey(reference, "reference");
			}
			if (attributionLibelle != null && attributionLibelle.equals("") == false) {
				bdgs.setObjectForKey(attributionLibelle, "attributionLibelle");
			}
			if (bdgs.objectForKey("exercice") == null) {
				bdgs.setObjectForKey(laCommandeEnCours().exercice(), "exercice");
			}
			NSArray<NSDictionary<String, Object>> lesArticles = FinderArticle.getRawRowArticles(laCommandeEnCours().editingContext(), bdgs);
			dg.setObjectArray(lesArticles);
			dg.setSelectedObjects(null);
			nextPage = (ArticleListeSelection) pageWithName("ArticleListeSelection");
			nextPage.initialiser();
		}
		return nextPage;
	}

	public void initialiser() {
		// Initalisation des bindings en fonction de la commande en cours
		WODisplayGroup dg = dgArticles();
		@SuppressWarnings("unchecked")
		NSMutableDictionary<String, Object> bdgs = dg.queryBindings();
		// bdgs.removeAllObjects();
		bdgs.setObjectForKey(laCommandeEnCours().exercice(), "exercice");
		EOFournisseur fournisseur = laCommandeEnCours().fournisseur();
		EOAttribution attribution = laCommandeEnCours().attribution();
		EOTypeAchat typeAchat = laCommandeEnCours().typeAchat();
		Boolean onMarche = (Boolean) bdgs.objectForKey("onMarche");

		if (onMarche != null && onMarche.booleanValue() == false) {
			bdgs.removeObjectForKey("onMarche");
		}
		if (fournisseur != null) {
			bdgs.setObjectForKey(fournisseur, "fournisseur");
			bdgs.setObjectForKey(fournisseur.fouCode(), "fouCode");
			bdgs.setObjectForKey(fournisseur.fouNom(), "fouNom");
		}
		if (attribution != null) {
			// attribution.attValide();
			bdgs.setObjectForKey(attribution, "attribution");
		}
		else {
			bdgs.setObjectForKey(new NSTimestamp(), "date");
		}
		if (typeAchat != null) {
			bdgs.setObjectForKey(typeAchat, "typeAchat");
		}

	}

	public boolean isRechercheAvanceeDirecte() {
		return isRechercheAvanceeDirecte;
	}

	public void setRechercheAvanceeDirecte(boolean isRechercheAvanceeDirecte) {
		this.isRechercheAvanceeDirecte = isRechercheAvanceeDirecte;
	}
}